"use strict";
// Copyright (c) David Brochart
// Distributed under the terms of the Modified BSD License.
Object.defineProperty(exports, "__esModule", { value: true });
const spin_js_1 = require("spin.js");
const base_1 = require("@jupyter-widgets/base");
const version_1 = require("./version");
require("../css/widget.css");
require("spin.js/spin.css");
class SpinnerModel extends base_1.DOMWidgetModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: SpinnerModel.model_name, _model_module: SpinnerModel.model_module, _model_module_version: SpinnerModel.model_module_version, _view_name: SpinnerModel.view_name, _view_module: SpinnerModel.view_module, _view_module_version: SpinnerModel.view_module_version, lines: 14, length: 38, width: 17, radius: 45, scale: 1, corners: 1, speed: 1, rotate: 0, animation: 'spinner-line-fade-quick', direction: 1, color: '#000000', fade_color: 'transparent', top: '50%', left: '50%', shadow: '0 0 1px transparent', z_index: 2000000000, class_name: 'spinner', position: 'absolute', _is_stopped: false });
    }
}
exports.SpinnerModel = SpinnerModel;
SpinnerModel.serializers = Object.assign({}, base_1.DOMWidgetModel.serializers);
SpinnerModel.model_name = 'SpinnerModel';
SpinnerModel.model_module = version_1.MODULE_NAME;
SpinnerModel.model_module_version = version_1.MODULE_VERSION;
SpinnerModel.view_name = 'SpinnerView';
SpinnerModel.view_module = version_1.MODULE_NAME;
SpinnerModel.view_module_version = version_1.MODULE_VERSION;
class SpinnerView extends base_1.DOMWidgetView {
    render() {
        this.el.classList.add('custom-widget');
        this.opt_names = [
            'lines',
            'length',
            'width',
            'radius',
            'scale',
            'corners',
            'speed',
            'rotate',
            'animation',
            'direction',
            'color',
            'fade_color',
            'top',
            'left',
            'shadow',
            'z_index',
            'class_name',
            'position'
        ];
        this.opts = {};
        this.opt_changed();
        this.spinner = new spin_js_1.Spinner(this.opts).spin(this.el);
        this.model.on_some_change(this.opt_names, this.opt_changed, this);
        this.model.on('change:_is_stopped', this.stop_changed, this);
    }
    opt_changed() {
        for (let opt of this.opt_names) {
            let opt_camel = opt;
            let i = opt.indexOf('_');
            console.log(opt, i);
            if (i != -1) {
                opt_camel = opt.substring(0, i).concat(opt[i + 1].toUpperCase(), opt.substring(i + 2));
            }
            console.log(opt_camel);
            this.opts[opt_camel] = this.model.get(opt);
        }
        if (this.spinner) {
            this.spinner.opts = this.opts;
            this.spinner.spin(this.el);
        }
    }
    stop_changed() {
        let is_stopped = this.model.get('_is_stopped');
        if (is_stopped) {
            this.spinner.stop();
        }
        else {
            this.spinner.spin(this.el);
        }
    }
}
exports.SpinnerView = SpinnerView;
//# sourceMappingURL=widget.js.map